# All files / src/custom-nodes/domain-lock-nodes DomainLockNode.ts

100% Statements 20/20
100% Branches 0/0
100% Functions 1/1
100% Lines 15/15

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    551x
    1x

    1x

    1x

    1x

    1x
    1x
    1x

    1x

    1x

    1x

    1x

    1x
    1x

    1x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../../container/ServiceIdentifiers';

    import * as format from 'string-template';

    import { IOptions } from '../../interfaces/options/IOptions';

    import { initializable } from '../../decorators/Initializable';

    import { DomainLockNodeTemplate } from '../../templates/custom-nodes/domain-lock-nodes/domain-lock-node/DomainLockNodeTemplate';

    import { AbstractCustomNode } from '../AbstractCustomNode';
    import { CryptUtils } from '../../utils/CryptUtils';
    import { RandomGeneratorUtils } from '../../utils/RandomGeneratorUtils';

    @injectable()
    export class DomainLockNode extends AbstractCustomNode {
        /**
         * @type {string}
         */
        @initializable()
        protected callsControllerFunctionName: string;

        /**
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            super(options);
        }

        /**
         * @param callsControllerFunctionName
         */
        public initialize (callsControllerFunctionName: string): void {
            this.callsControllerFunctionName = callsControllerFunctionName;
        }

        /**
         * @returns {string}
         */
        protected getTemplate (): string {
            let domainsString: string = this.options.domainLock.join(';'),
                [hiddenDomainsString, diff]: string[] = CryptUtils.hideString(domainsString, domainsString.length * 3);

            return format(DomainLockNodeTemplate(), {
                domainLockFunctionName: RandomGeneratorUtils.getRandomVariableName(),
                diff: diff,
                domains: hiddenDomainsString,
                singleNodeCallControllerFunctionName: this.callsControllerFunctionName
            });
        }
    }